/************************************************************
 * EPAPairingVerticalNode

	class EPAPairingVerticalNode
	{
		Constructor:
			EPAPairingVerticalNode();
			
		Events:

			EpaOnCompleted 		-> 	__EPAPairingVerticalNode_OnEpaCompleted;
			EpaOnLayoutChanged = 	->	__OnPairNodeLayoutChanged;
			EpaOnDragStart = 	->	__EPAPairingVerticalNode_OnEpaDragStart;
			EpaOnDragging = 	->	__EPAPairingVerticalNode_OnEpaDragging;
			EpaOnDragEnd = 		->	__EPAPairingVerticalNode_OnEpaDragEnd;
			EpaOnPairLineChanged = 	->	__EPAPairingVerticalNode_OnEpaPairLineChanged;
		
		public:	
			n/a
			
		protected:
			n/a
	}
*/




function __EPAPairingVerticalNode_SetCurve(Curve,Src)
{		  
      x1=Curve.linestartx;
      y1=Curve.linestarty;
      x2=Curve.lineendx;
      y2=Curve.lineendy;
	    
      if (y1<=y2)
      {
        ctrltxt1=x1+','+eval(y1+80);
        ctrltxt2=x2+','+eval(y2-80);
      } 
      else {
        ctrltxt1=x1+','+eval(y1-80);
        ctrltxt2=x2+','+eval(y2+80);
      }
      Curve.control1=ctrltxt1;
      Curve.control2=ctrltxt2;
      Curve.style.visibility='visible';
}

function __EPAPairingVerticalNode_OnEpaDragging() 
{
  EPARTLCheckAutoScroll();
}

function __EPAPairingVerticalNode_OnEpaDragEnd()
{
  Src=window.event.srcElement;
  Obj = Src.Obj;
  cl=document.body.Connectionline;
  if (cl)
  {
    cl.outerText='';
    document.body.Connectionline=null;
  }
}

function __EPAPairingVerticalNode_OnEpaDragStart()
{
EpaDragAndDrop.DragEfectName = 'Empty';
Src=window.event.srcElement;
Obj = Src.Obj;
document.body.PairingSrc=Src;
}

function __EPAPairing_DisplayCorrectLine(Ln)
{
  if (Ln==null) return;
  line=document.all(Ln.Name);
  if (line) line.strokecolor='#33B545' ;
}


function __EPAPairingVertical_DisplayHilitedLine(Ln)
{
  if (Ln==null) return;
  line=document.all(Ln.Name);
  if (line) 
  {
    line.strokecolor='#4D9EF3' ;
    line.stroke.dashstyle='dash';
  }
}

function __EPAPairingVertical_DisplayNormalLine(Ln)
{
  if (Ln==null) return;
  line=document.all(Ln.Name);
  if (line) 
  {
    line.strokecolor='#4D9EF3' ;
    line.stroke.dashstyle='solid';
  }
}

function __EPAPairingVertical_DisplayRemovedLine(Ln)
{
  if (Ln==null) return;
  line=document.all(Ln.Name);
  //line.insertAdjacentHTML("BeforeEnd", "<v:stroke dashstyle='dash'/>");
  if (line) line.stroke.dashstyle='dash';
}

function __EPAPairingVertical_DisplayHilitedNode(Node)
{
  if (Node==null) return;
  Node.className=Node.defClassName+ ' RTS_PairingHilited';
  if (Node.nodeimg==null) return;  
  Node.nodeimg.filters[0].src = Node.IMsel;
}

function __EPAPairingVertical_DisplayHilitedPairedNode(Node)
{
  if (Node==null) return;
  Node.className=Node.defClassName+ ' RTS_PairingPairedHilited';
  if (Node.nodeimg==null) return;
  Node.nodeimg.filters[0].src = Node.IMpsel;
}


function __EPAPairingVertical_DisplayPairedNode(Node)
{
  if (Node==null) return;
  Node.className=Node.defClassName+ ' RTS_PairingNormal';
  if (Node.nodeimg==null) return;
  Node.nodeimg.filters[0].src = Node.IMp;

}

function __EPAPairing_DisplayWrongPairedNode(Node)
{
  if (Node==null) return;
  Node.className=Node.defClassName+ ' RTS_PairingNormal';
  if (Node.nodeimg==null) return;
  Node.nodeimg.filters[0].src = Node.IMwrong;
}

function __EPAPairing_DisplayCorrectPairedNode(Node)
{
  if (Node==null) return;
  Node.className=Node.defClassName+ ' RTS_PairingNormal';
  if (Node.nodeimg==null) return;
  Node.nodeimg.filters[0].src = Node.IMcorrect;
}



function __EPAPairingVertical_DisplayNormalNode(Node)
{
  if (Node==null) return;
  Node.className=Node.defClassName+ ' RTS_PairingNormal';
  if (Node.nodeimg==null) return;
  Node.nodeimg.filters[0].src = Node.IMnorm;
}

function __EPAPairingVertical_DisplayTargetNode(Node)
{
  if (Node==null) return;
  Node.className=Node.defClassName+ ' RTS_PairingTarget';
  Node.nodeimg.filters[0].src = Node.IMsel;
}


function __OnPairVerticalNodeLayoutChanged() 
{  
  var Src=window.event.srcElement;
  isDragging=EpaDragAndDrop.Dragging();
  Obj = Src.Obj;
  
  switch (Obj.ExStatus) 
  {
    case es_Normal: 
    {
      switch (Obj.Layout) 
      {
	case pair_DragTarget:
	{
	        __EPAPairingVertical_DisplayTargetNode(Src);
          cline=document.body.Connectionline;
          srcnode=document.body.PairingSrc;
          if (cline) 
      	  {
      	    S=EPAGetPosition(Src.nodeimg);
            x2=S.x + Src.nodeimg.offsetWidth/2;
            y2=S.y;
            cline.to=x2+","+y2;
            cline.lineendx=x2;
            cline.lineendy=y2;
            Src.htc.SetCurve(cline,Src);
            cline.target=Src;
            cline.style.visibility='visible';
      	  }
          else 
          {
            lname="_dividerimg"+srcnode.id;
      	    EPAPairingVerticalNode_Drawline(srcnode,Src,'#4D9EF3',lname)
            document.body.Connectionline=eval(lname);
          }
          srcnode.nodeimg.filters[0].src = srcnode.IMsel;
          __EPAPairingVertical_DisplayRemovedLine(Obj.Line);  	
	        break;
        }; 
              
        case pair_HLited: 
        {
	  if (!isDragging) 
	    __EPAPairingVertical_DisplayHilitedNode(Src);
	  else
	  {
	    if (document.body.PairingSrc.Direction!=Src.Direction) __EPAPairingVertical_DisplayHilitedNode(Src);
	  }
          break;
        }; 
              
        case pair_Normal: 
        {
          cline=document.body.Connectionline;
          srcnode=document.body.PairingSrc;
          if (cline) 
      	    if (cline.target==Src) 
      	      {
            		cline.target='';
            		cline.style.visibility='hidden';
            		srcnode.nodeimg.filters[0].src = srcnode.IMsel;
      	      }
          __EPAPairingVertical_DisplayNormalNode(Src);
          break;
        }
          
        case pair_HLitePairedTarget: 
	{
	  if (!isDragging) 
	    __EPAPairingVertical_DisplayHilitedNode(Src);
	  else
	  {
	    if (document.body.PairingSrc.Direction!=Src.Direction) __EPAPairingVertical_DisplayHilitedNode(Src);
	  }
          break;
        }
              
        case pair_HLitePairedSource: 
        {
	  if (!isDragging) 
	  {
	    __EPAPairingVertical_DisplayHilitedPairedNode(Src);
	    __EPAPairingVertical_DisplayHilitedPairedNode(Obj.Partner);
	    __EPAPairingVertical_DisplayHilitedLine(Obj.Line);  	
          }
	  else
	  {
	    if (document.body.PairingSrc.Direction!=Src.Direction)
	    {
	      __EPAPairingVertical_DisplayHilitedPairedNode(Src);
	    }
	  }
          		//EPAPairingVerticalNode_Showdivider(Src);
          break;
	}
          
        case pair_Paired: 
        {
          cline=document.body.Connectionline;
          srcnode=document.body.PairingSrc;
          if (cline) 
	    if (cline.target==Src) 
	      {
		cline.target='';
		cline.style.visibility='hidden';
		srcnode.nodeimg.filters[0].src = srcnode.IMsel;
	      }
          
          __EPAPairingVertical_DisplayPairedNode(Src);
          __EPAPairingVertical_DisplayPairedNode(Obj.Partner);
          __EPAPairingVertical_DisplayNormalLine(Obj.Line);
          		//EPAPairingVerticalNode_Hidedivider(Src);
	  break;
        }
     }
     break;
   }
   case es_AfterEval: 
   {
      if ((Obj.Line == null)||(Obj.Line.LineStyle!=pl_Normal))
     {
       __EPAPairing_DisplayWrongPairedNode(Src);
     }
     else
     {
     __EPAPairing_DisplayCorrectPairedNode(Src);
     __EPAPairing_DisplayCorrectLine(Obj.Line);
     }     
     break;
   }
 };
 
 }


function EPAPairingVerticalNode_Removeline(line)
{
  line.outerText='';
}

function EPAPairingVerticalNode_Drawline(Source,Target,Color,lname,linestyle,zindex)
{
	/*
  Src = window.event.srcElement;  
  if (!lname) lname="_pairvmlline"+Source.id;
  nodeimgoffsetx=10;
  nodeimgoffsety=10;  
  S=EPAGetPosition(Source.nodeimg);
  T=EPAGetPosition(Target.nodeimg);
  x1=S.x+1;  // +1 z duvodu problemu, kdyz je x1==x2
  y1=S.y;  
  x2=T.x;
  y2=T.y;
  DX=nodeimgoffsetx;DY=nodeimgoffsety;

  if (y1<y2)
  {
    c1=x1+','+eval(y1+80);
    c2=x2+','+eval(y2-80);
  } 
  else {
    c1=x1+','+eval(y1-80);
    c2=x2+','+eval(y2+80);
  }
  
  
  if (!Color) Color="#FD9743";
  if (zindex==null) zindex=11; 
  elementtext="<v:curve id='"+lname+"' from='"+x1+","+y1+"' to='"+x2+","+y2+"'  control1='"+c1+"' control2='"+c2+"' strokecolor='"+Color+"' strokeweight='1.5pt' style='position:absolute; z-index:"+zindex+"; top:"+DY+";left:"+DX+"'>";
  elementtext+="<v:fill on=\"false\" />";
  if (linestyle!=null) elementtext+="<v:stroke dashstyle='"+linestyle+"' />";
  elementtext+="</v:curve>";
  Source.insertAdjacentHTML("BeforeEnd", elementtext);
  cline=eval(lname);
  cline.linestartx=x1;
  cline.linestarty=y1;
  //window.alert(Source.outerHTML);
//	Source.Visibleline=eval(lname);
//	Target.Visibleline=eval(lname);
  */
  Src = window.event.srcElement;  
  if (!lname) lname="_pairvmlline"+Source.id;
  nodeimgoffsetx=0;
  nodeimgoffsety=8;  
  S=EPAGetPosition(Source.nodeimg);
  T=EPAGetPosition(Target.nodeimg);

  if (S.x<=T.x)
  {
    S.x+=nodeimgoffsetx;T.x-=nodeimgoffsetx;
  }
  else
  {
    T.x+=nodeimgoffsetx;S.x-=nodeimgoffsetx;
  }

  x1=S.x+Source.nodeimg.offsetWidth/2+1;
  y1=S.y;  
  x2=T.x+Source.nodeimg.offsetWidth/2;
  y2=T.y;
  DX = nodeimgoffsetx;DY = nodeimgoffsety;

  if (y1<y2)
  {
    c1=x1+','+eval(y1+80);
    c2=x2+','+eval(y2-80);
  } 
  else {
    c1=x1+','+eval(y1-80);
    c2=x2+','+eval(y2+80);
  }
  
  if (!Color) Color="#FD9743";
  if (zindex==null) zindex=11; 
  elementtext="<v:curve id='"+lname+"' from='"+x1+","+y1+"' to='"+x2+","+y2+"'  control1='"+c1+"' control2='"+c2+"' strokecolor='"+Color+"' strokeweight='2pt' style='position:absolute; z-index:"+zindex+"; top:"+DY+";left:0'>";
  elementtext+="<v:fill on=\"false\" />";
  if (linestyle!=null) elementtext+="<v:stroke dashstyle='"+linestyle+"' />";
  elementtext+="</v:curve>";
  Source.insertAdjacentHTML("BeforeEnd", elementtext);
  cline=eval(lname);
  cline.linestartx=x1;
  cline.linestarty=y1;
  cline.DX = DX;

};

function EPAPairingVerticalNode_Showdivider(Source)
{
  Target=Source.Obj.Partner;
  S=EPAGetPosition(Source.nodeimg);
  T=EPAGetPosition(Target.nodeimg);

  Img = document.createElement ('span');
  Source.appendChild (Img);
  Source.divimg=Img;

  Img.style.position="absolute";
  Img.style.width=1;
  Img.style.height=1;
  Img.style.top=Math.floor((S.y+T.y)/2)-10;
  Img.style.left=Math.floor((S.x+T.x)/2)-10;
  Img.style.zIndex=13;

  Img2 = document.createElement ('span');
  Img.appendChild (Img2);
  Img2.innerHTML='&nbsp;';
  Img2.style.width=30;
  Img2.style.height=30;
  Img2.style.filter="progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+crs_ImagesPath+"pairingvertical/pairing_divider.png', sizingMethod='image')";	

  uhel=Math.atan(Math.abs(S.y-T.y)/Math.abs(S.x-T.x));
  if (((S.y<T.y)&&(S.x>T.x))||((S.y>T.y)&&(S.x<T.x))) uhel=-uhel;
};

function EPAPairingVerticalNode_Hidedivider(Src)
{
  if (Src.divimg) 
  {
    Src.divimg.outerText='';
    Src.divimg="";
  }
}

function __EPAPairingVerticalNode_SetImgPosition(Src)
{
  pos=EPAGetAbsolutePosition(Src);  
  // point picture
  Img=Src.nodeimg;
  Img.style.left=(pos.x+Src.offsetWidth/2-20/2);
  if (Src.Direction==1) 
    Img.style.top=pos.y-Src.nodetotextdist-28;
  else 
    Img.style.top=pos.y+Src.offsetHeight+Src.nodetotextdist;

/*
  // background area image
  Imgbg=Src.ImgBg;
  Imgbg.style.top=pos.y;
  if (Src.Direction==1) 
    Imgbg.style.left=pos.x-Src.nodetotextdist-20;
  else 
    Imgbg.style.left=pos.x;
  Imgbg.style.height=SrcPrnt.offsetHeight;
  Imgbg.style.width=SrcPrnt.offsetWidth+Src.nodetotextdist+20;
*/
}




// ******************************** java class EPAPairingVerticalNode ***********************

function EPAPairingVerticalNode() 
{
  
  Src=window.event.srcElement;
  Obj=Src.Obj;

  Src.style.cursor='default';      
  Obj.Styles=Obj.Styles|cs_DragStartOnClick|cs_Evaluatable;
  
  if (Src.Direction==0) 
  {
    Obj.GroupMemberOf='PairLeft:' + Src.GroupId;
    Src.IMnorm = crs_ImagesPath+'pairingvertical/bulletl.png';
    Src.IMsel = crs_ImagesPath+'pairingvertical/bullet_selectedl.png';
    Src.IMp = crs_ImagesPath+'pairingvertical/bullet_pairedl.png';
    Src.IMpsel = crs_ImagesPath+'pairingvertical/bullet_pairedl_h.png';
    Src.IMwrong = crs_ImagesPath+'pairingvertical/bulletl_wrong.png';
    Src.IMcorrect = crs_ImagesPath+'pairingvertical/bulletl_correct.png';        

  }
  if (Src.Direction==1) 
  {
    Obj.GroupMemberOf='PairRight:' + Src.GroupId;
    Src.IMnorm = crs_ImagesPath+'pairingvertical/bulletr.png';
    Src.IMsel = crs_ImagesPath+'pairingvertical/bullet_selectedr.png';
    Src.IMp = crs_ImagesPath+'pairingvertical/bullet_pairedr.png';    
    Src.IMpsel = crs_ImagesPath+'pairingvertical/bullet_pairedr_h.png';
    Src.IMwrong = crs_ImagesPath+'pairingvertical/bulletr_wrong.png';
    Src.IMcorrect = crs_ImagesPath+'pairingvertical/bulletr_correct.png';     
  }
  
  Src.IMdis = crs_ImagesPath+'pairingvertical/bullet_disabled.png';  

  
  Src.rand=0.5-Math.random();
  
  Src.htc=new __EPAPairingVerticalNode_EPAPairingVerticalNode();

  Src.EpaOnCompleting=Src.htc.EpaOnCompleting;
}

function __EPAPairingVerticalNode_EPAPairingVerticalNode() 
{
    if (!Src.nodetotextdist) Src.nodetotextdist=10;
}


function __EPAPairingVerticalNode_EpaOnSetDefaultLayout()
{
  Src=window.event.srcElement;

  Src.defClassName=Src.className;
  pos=EPAGetAbsolutePosition(Src);
  //Img = document.createElement ('span');
  Img = document.createElement ('img');
  Src.appendChild (Img);
  Src.nodeimg=Img;
  //Img.innerHTML='&nbsp;';
  Img.src=crs_ImagesPath+'nic.gif';
  Img.style.position="absolute";
  Img.style.width=20;
  Img.style.height=20;
  

  Img.style.filter="progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+Src.IMnorm+"', sizingMethod='image')";

  Img.style.zIndex=20;

/*
  Imgbg = document.createElement ('span');
  Imgbg.style.position="absolute";
  Imgbg.style.zIndex=3;
  Src.appendChild (Imgbg);
  Src.ImgBg=Imgbg;
*/  

  __EPAPairingVerticalNode_SetImgPosition(Src);

}

function __EPAPairingVerticalNode_EpaOnSRRecognize()
{
  Src=window.event.srcElement; // _MD musi se odkomentovat (jen pro simulaci);
  Obj=Src.Obj;
  if (Src.Direction==0) 
    grp='PairLeft';
  else
    grp='PairRight';
  prnt=Obj.GroupParent(grp);
  if (!prnt.SrActive)
  {
    prnt.SrActive = Src;
    __EPAPairingVertical_DisplayHilitedPairedNode(Src);

  }  
  else 
  {
    if (Src.Direction==prnt.SrActive.Direction)
	  return;
    lname="_dividerimg"+prnt.SrActive.id;
    delold=true;
    prnt.Create_Line(prnt.SrActive,Src,pl_Normal,delold);
    prnt.SrActive=null;
  }  
}

function __EPAPairingVerticalNode_EpaOnCompleting()
{
  Src=window.event.srcElement;
  Src.EpaOnDragStart = Src.htc.EpaOnDragStart;
  Src.EpaOnDragging = Src.htc.EpaOnDragging;
  Src.EpaOnDragEnd = Src.htc.EpaOnDragEnd;
  Src.EpaOnLayoutChanged=Src.htc.EpaOnLayoutChanged;
  Src.EpaOnExStatusChanged=Src.htc.EpaOnExStatusChanged;  		
  Src.EpaOnSetDefaultLayout=Src.htc.EpaOnSetDefaultLayout;  		
  Src.EpaOnSrRecognize=Src.htc.EpaOnSRRecognize;  
}

// **** metody (eventy) **********

__EPAPairingVerticalNode_EPAPairingVerticalNode.prototype.EpaOnLayoutChanged = __OnPairVerticalNodeLayoutChanged;
__EPAPairingVerticalNode_EPAPairingVerticalNode.prototype.EpaOnDragStart = __EPAPairingVerticalNode_OnEpaDragStart;
__EPAPairingVerticalNode_EPAPairingVerticalNode.prototype.EpaOnDragging = __EPAPairingVerticalNode_OnEpaDragging;
__EPAPairingVerticalNode_EPAPairingVerticalNode.prototype.EpaOnDragEnd = __EPAPairingVerticalNode_OnEpaDragEnd;
__EPAPairingVerticalNode_EPAPairingVerticalNode.prototype.SetCurve=__EPAPairingVerticalNode_SetCurve;
__EPAPairingVerticalNode_EPAPairingVerticalNode.prototype.EpaOnCompleting= __EPAPairingVerticalNode_EpaOnCompleting;
__EPAPairingVerticalNode_EPAPairingVerticalNode.prototype.EpaOnSetDefaultLayout= __EPAPairingVerticalNode_EpaOnSetDefaultLayout;
__EPAPairingVerticalNode_EPAPairingVerticalNode.prototype.EpaOnSRRecognize = __EPAPairingVerticalNode_EpaOnSRRecognize;

// ******************************** java class EPAPairingVertical ***********************


function __EPAPairingVertical_SetPosition()
{
  /*
  EPAPairingVertical_SetHPosition('PairLeft');
  EPAPairingVertical_SetHPosition('PairRight');
  EPAPairingVertical_SetVPosition('PairLeft');
  EPAPairingVertical_SetVPosition('PairRight');
  */
}

function EPAPairingVertical_SetVPosition(Group)
{
  Src = window.event.srcElement;  
  Obj = Src.Obj;
  arr = new VBArray (Obj.GroupChilds(Group));
  firstitem=arr.getItem(0);
  lastitem=arr.getItem(arr.ubound(1));
  
  
  Img=firstitem.vlineimg;      
  Fn = EPAGetPosition(firstitem.nodeimg);
  F = EPAGetAbsolutePosition(firstitem);
  L = EPAGetAbsolutePosition(lastitem);

  
  Img.style.left=0;  //-eval(Src.verticaloverflow/2)
  liney=Fn.y;

  if (firstitem.Direction==0) liney-=eval(Src.verticalindent);
  if (firstitem.Direction==1) liney+=eval(Src.verticalindent)+firstitem.nodeimg.offsetHeight;

  Img.style.top=liney;
  Img.width = Math.abs(L.x-F.x)+lastitem.offsetWidth+2*eval(Src.horizontaloverflow)+(firstitem.rand*eval(Src.horizontalrange));
}

function EPAPairingVertical_SetHPosition(Group)
{
  Src = window.event.srcElement;  
  Obj = Src.Obj;

  arr = new VBArray (Obj.GroupChilds(Group));
  cnt = arr.ubound(1);
  for (i=0;i<=cnt;i++)
  {
    oo=arr.getItem(i);
    __EPAPairingVerticalNode_SetImgPosition(oo);
    
    if (i<=cnt-1)
    {
      n1 = EPAGetAbsolutePosition(oo);
      n2 = EPAGetAbsolutePosition(oo.nodeimg);
      Img=oo.lineimg;
      if (oo.Direction==0)  Img.style.top=n2.y+oo.nodeimg.offsetHeight-Img.height+eval(Src.verticaloverflow);
      if (oo.Direction==1)  Img.style.top=n2.y-eval(Src.verticaloverflow);  			  
    //Img.style.top=n1.y+Src.htc.linedist;	    
      y1=oo.offsetWidth;
      y2=EPAGetAbsolutePosition(arr.getItem(i+1)).x;
      Img.style.left=(n1.x+y1+y2)/2;	
    }
  }
}

function __EPAPairingVertical_EpaOnCompleted()
{
  Src = window.event.srcElement;  
  Obj = Src.Obj;

  //DrawGridVertical('PairLeft');
  //DrawGridVertical('PairRight');
}

function DrawGridVertical(Group)
{
  Src = window.event.srcElement;  
  Obj = Src.Obj;
  arr = new VBArray (Obj.GroupChilds(Group));
  firstitem=arr.getItem(0);
  
  Img = document.createElement ('img');
  Img.src=crs_ImagesPath+'gray1x2.gif';
  Img.height=2;
  Img.style.position="absolute";
  Img.style.zIndex=2;
  //Src.parentElement.appendChild (Img);
  firstitem.appendChild (Img);
  firstitem.vlineimg=Img;
  EPAPairingVertical_SetVPosition(Group);


  for (i=0;i<=arr.ubound(1)-1;i++)
  {
    oo=arr.getItem(i);
    n1 = EPAGetAbsolutePosition(oo);
    n2 = EPAGetAbsolutePosition(oo.nodeimg);
    Img = document.createElement ('img');
    Img.src=crs_ImagesPath+'gray2x1.gif';
    Img.width=2;
    Img.style.position="absolute";
    Img.style.zIndex=1;
    oo.appendChild (Img);
    oo.lineimg=Img;
    if (i==0) 
    {
      if (arr.ubound(1)>0) 
      {
	      Src.htc.linedist=Math.abs(n1.x-oo.offsetWidth-EPAGetPosition(arr.getItem(i+1)).x)/2;
      }
      else 
	      Src.htc.linedist=5; // existuje pouze jeden node
    }
    if (oo.Direction==0)  w=Math.abs(n1.y-n2.y)+oo.nodeimg.offsetHeight+2*eval(Src.verticaloverflow);
    if (oo.Direction==1)  w=Math.abs(n1.y-n2.y)+oo.offsetHeight+2*eval(Src.verticaloverflow);
    Img.height=w+(0.5-Math.random())*eval(Src.verticalrange);
  }
  EPAPairingVertical_SetHPosition(Group);    

}


function __EPAPairingVertical_EpaOnPairLineDelete()
{
  Ln=window.event.Line;
  lineobj=eval(Ln.Name);
  EPAPairingVerticalNode_Hidedivider(Ln.FromItem);
  EPAPairingVerticalNode_Removeline(lineobj)
  EPAPairingVerticalNode_Hidedivider(Src);
}

function __EPAPairingVertical_EpaOnPairLineAdd()
{
  Src=window.event.srcElement;
  Obj = Src.Obj;
  Ln=window.event.Line;
  /*
  if (Obj.Partner) {
  		 EPAPairingVerticalNode_Drawline(Src,Obj.Partner);
  		 }
  	else {
  		EPAPairingVerticalNode_Removeline(Src.Visibleline);
  		Src.Visibleline="";
  		EPAPairingVerticalNode_Hidedivider(Src);
  		};
  */    
  lstyle="solid";zindex=10;
  switch (Ln.LineStyle) 
  {
    case pl_Normal: {Color='#4D9EF3'; break};
    case pl_Wrong: {
                    __EPAPairing_DisplayWrongPairedNode(Ln.FromItem);
                    __EPAPairing_DisplayWrongPairedNode(Ln.ToItem);
                    Color='#F38F58'; break;
                    };
    case pl_Missing: {Color='#3EB950';lstyle="dash";zindex=11; break};
  };
  EPAPairingVerticalNode_Drawline(Ln.FromItem,Ln.ToItem,Color,Ln.Name,lstyle,zindex);

}


function __EPAPairingVertical_EpaOnExStatusChanged()
{
  Src=window.event.srcElement;
  Obj = Src.Obj;
  switch (Obj.ExStatus) 
  {
    case es_Removed: 
    {
      Items = new VBArray (Obj.GroupChilds ('PairLeft'));
      for (i=0;i<=Items.ubound(1);i++)
      {
	It = Items.getItem(i);
	It.className=It.defClassName+ ' RTS_PairingRemoved';
    	It.nodeimg.filters[0].src=crs_ImagesPath+"pairingvertical/bullet_disabled.png";                    
      };
      Items = new VBArray (Obj.GroupChilds ('PairRight'));
      for (i=0;i<=Items.ubound(1);i++)
      {
	It = Items.getItem(i);
        It.className=It.defClassName+ ' RTS_PairingRemoved';
    	It.nodeimg.filters[0].src=It.IMdis;                    
      };
      break;
     }
  }
}



function EPAPairingVertical() 
{


  Src=window.event.srcElement;
  Obj=Src.Obj;
  Obj.GroupHeadOf='PairLeft:'+ Src.GroupId +'; PairRight:' + Src.GroupId;
  Obj.GroupMemberOf='Eval:'+ document.body.id;
  Obj.Styles = Obj.Styles & (~cs_CaptureMouse);
  
  Obj.CorrectAnswer=Src.CorrectPairs;

  Src.style.position='relative';  // tvori coord. system pro nodes
   
  Src.htc=new __EPAPairingVertical_EPAPairingVertical();
  
  
  Src.EpaOnCompleting=Src.htc.EpaOnCompleting;
}

function __EPAPairingVertical_EPAPairingVertical()
{
}

function __EPAPairingVertical_EpaOnCompleting()
{
  Src=window.event.srcElement;
  Src.EpaOnCompleted=Src.htc.EpaOnCompleted;
  Src.EpaOnWindowResize=Src.htc.EpaOnWindowResize;
  Src.EpaOnPairLineAdd = Src.htc.EpaOnPairLineAdd;
  Src.EpaOnPairLineDelete = Src.htc.EpaOnPairLineDelete;
  Src.EpaOnExStatusChanged=Src.htc.EpaOnExStatusChanged;  
}

// **** metody (eventy) **********

__EPAPairingVertical_EPAPairingVertical.prototype.EpaOnCompleted = __EPAPairingVertical_EpaOnCompleted;
__EPAPairingVertical_EPAPairingVertical.prototype.EpaOnWindowResize= __EPAPairingVertical_SetPosition;
__EPAPairingVertical_EPAPairingVertical.prototype.EpaOnPairLineAdd = __EPAPairingVertical_EpaOnPairLineAdd;
__EPAPairingVertical_EPAPairingVertical.prototype.EpaOnPairLineDelete = __EPAPairingVertical_EpaOnPairLineDelete;
__EPAPairingVertical_EPAPairingVertical.prototype.EpaOnExStatusChanged=__EPAPairingVertical_EpaOnExStatusChanged;
__EPAPairingVertical_EPAPairingVertical.prototype.EpaOnCompleting= __EPAPairingVertical_EpaOnCompleting;