/* $Header: c:/cvsroot/webapp/Data/Epa/All/AllRuntime1/scripts/RuntimeLibrary.js,v 1.17 2005/02/18 14:50:41 jiris Exp $ */
function EpaIsWhiteSpace(c)
{
  return c == ' ' || 
    c == '\f' || 
    c == '\n' || 
    c == '\r' || 
    c == '\t';
}

function EPARTLSetupSoundTree(object)
{
  Src = window.event.srcElement;      
  //Init groups
  Src.Obj.GroupHeadOf = CrsGroupPrefixSoundItem + ':' + Src.GroupHeadId;	      
  if (Src.GroupId != null)
    Src.Obj.GroupMemberOf = CrsGroupPrefixSoundItem + ':' + Src.GroupId;

  Src.Obj.Styles = Src.Obj.Styles & (~cs_CaptureMouse) & (~cs_AllowMouseActive) | cs_NotMouseControl;
  Src.Obj.DontPlayOnClick = true;	            
}

function EPARTLInitializeRotatedBox(object, rotation)
{
  //Get original size
  Width = object.parentNode.offsetWidth + 5;
  Height = object.parentNode.offsetHeight + 5;    
  
  //Init filters
  rad = rotation;
  costheta = Math.cos(rad);
  sintheta = Math.sin(rad);

  object.filters.item(0).M11 = costheta;
  object.filters.item(0).M12 = -sintheta;
  object.filters.item(0).M21 = sintheta;
  object.filters.item(0).M22 = costheta;      
  
  //Update size after rotation
  Diagonal = Math.sqrt(Width * Width + Height * Height );
  InnerAngle = Math.acos(Width / Diagonal);
  InnerAngle90 = Math.PI / 2 - InnerAngle;
    
  object.parentNode.style.width = Math.round(Math.max(Diagonal * Math.abs(Math.cos(InnerAngle - rotation)), Diagonal * Math.abs(Math.cos(-InnerAngle - rotation))));
  object.parentNode.style.height = Math.round(Math.max(Diagonal * Math.abs(Math.cos(InnerAngle90 - rotation)), Diagonal * Math.abs(Math.cos(-InnerAngle90 - rotation))));
}

function EPARTLLocalise(obj)
{
  return EPARTLLocalisePart(obj, 0);
}

function _EPARTLLocaliseASSERT(obj, attrName)
{
  alert("ASSERT: EPARTLLocalisePart failed for " + obj.id + ". '" + attrName + "' attribute is missing");
  return null;
}

function _EPARTLLocaliseAttr(obj, attrName, iPart)
{
  if (iPart > 0)
    attr = eval("obj." + attrName + iPart);
  else  
    attr = eval("obj." + attrName);    
  if (attr == null)  
    return _EPARTLLocaliseASSERT(obj, attrName);      
  else
    return attr;
}
  
function EPARTLLocalisePart(obj, iPart)
{
  var attrName1;
  var attrName2;
  bUseNative = true; //_PG cist z runtime
  if (bUseNative)
  {
    attrName1 = "Native";
    attrName2 = "Foreign";
  }
  else
  {
    attrName1 = "Foreign";
    attrName2 = "Native";
  }
  attr = _EPARTLLocaliseAttr(obj, attrName1, iPart);
  if (attr != null)
  {
    _EPARTLLocaliseAttr(obj, attrName2, iPart);    
    return attr;
  }
  else      
    return null;  
}

function EPAGetPosition(obj) 
{
  r = new Array();
  if (obj) 
  {
    r['x'] = obj.offsetLeft;
    r['y'] = obj.offsetTop;
  }  
  return r;
}

function EPAGetInnerHeightDifference(obj) 
{
  var a;

  a=obj.parentElement;
  while (a)
  {
    if (a.tagName=='TD')
    {
      flag=a.style.verticalAlign;
      if (!flag) flag=a.vAlign;
      if (!flag) flag='middle';
      if (flag=='top') 	return(0);

      refsp = document.createElement ('span');    
      a.insertBefore(refsp,a.firstChild);
      y1=a.firstChild.offsetTop;
      refsp.removeNode(false);
      a.appendChild(refsp);
      y2=refsp.offsetTop+refsp.offsetHeight;
      refsp.removeNode(false);
      result=a.offsetHeight-(y2-y1)-2*a.clientTop;    // 2*a.clientTop = 2*border
      if (flag=='middle') 
	result=Math.floor(result/2);
      return(result);
      break;
    }
    a=a.parentElement;
  }
  return(0);
}

function EPAGetRelativePosition(obj) 
{
  var a,posx,posy;
  a=obj;
  posx=0;posy=0;
  while (a)
  {
    posx+=a.offsetLeft;posy+=a.offsetTop;
    a=a.offsetParent;
    if (a)
    {
      if (a.currentStyle.position!='static') 
        break;
      if ((a.currentStyle.overflowY!='visible')||(a.currentStyle.overflowX!='visible')||(a.currentStyle.overflow!='visible')) 
        break;    
    } 
  }
  r = new Array();
  r['x'] = posx;
  r['y'] = posy;  
  return r;

}

function EPAGetOffsetPosition(obj,realInnerContent) 
{
/*  
  var a,posx,posy,overflowX,overflowY;
  a=obj;
  posx=0;posy=0;
  overflowX=0;overflowY=0;
  while (a)
  {
    posx+=a.offsetLeft;posy+=a.offsetTop;
    a=a.offsetParent;
    if (a)
    {
      if (a.style.position) break;
      if ((a.style.overflowY)||(a.style.overflowX)) 
      {
	pos2=EPAGetOffsetPosition(a);
	overflowY+=pos2.y;
	overflowX+=pos2.x;
      }
    } 
  }
  
  if (realInnerContent)
  {
    qq=EPAGetInnerHeightDifference(obj);
    overflowY+=qq;
  }
    
  r = new Array();
  r['x'] = posx-overflowX;
  r['y'] = posy-overflowY;  
  return r;
*/
  if (realInnerContent) 
    realc=true;
  else 
    realc=false;
  Utils.GetElementPosition(obj,realc);
  r = new Array();
  r['x'] = obj.X;
  r['y'] = obj.Y;  
  return r;
  
}

function EPAGetAbsolutePosition_SoundItemsVersion(Src) 
{
var a;
  a=Src;
  posx=0;posy=0;
  overflowX=0;overflowY=0;  
  while (a)
  {
    posx+=a.offsetLeft;posy+=a.offsetTop;
    a=a.offsetParent;  
    if (a)
    {
      if ((a.style.overflowY)||(a.style.overflowX)) 
      {
        pos2=EPAGetOffsetPosition(a);
        overflowY+=pos2.y;
        overflowX+=pos2.x;
      }
    }
  }
  r = new Array();
  r['x'] = posx-overflowX;
  r['y'] = posy-overflowY;  
  return r;
}

function EPAGetAbsolutePosition(Src) 
{

  r = new Array();
  r['y'] = Utils.GetElementPosition(Src,true);
  r['x'] = Src.X;

  return r;
}


function EPAGetPositionOnScreen(obj) 
{
var a;
  a=obj;//posx=0;posy=0;
  posn=EPAGetAbsolutePosition(obj) ;
//  window.alert(posn.x+':'+posn.y);


  posx=posn.x;posy=posn.y;
  while (a.parentElement)
  {
 	if (a.ScrollArea)
	{
	posS=EPAGetAbsolutePosition(a);
//	window.alert(posS.x+':'+posS.y);
	posx+=posS.x;posy+=posS.y;

 	posx-=a.scrollLeft;posy-=a.scrollTop;
	//posx+=a.scrollLeft;posy+=a.scrollTop;
	}
 	a=a.parentElement;
  }
//  window.alert('return:'+posx+':'+posy);
  r = new Array();
  r['x'] = posx;
  r['y'] = posy;  
  return r;
}



function debugElmXY(el)
{
var msg = "";
msg = "ID: \t\t" + el.id + "\n";
msg += "Tag: \t\t" + el.tagName + "\n\n";
msg += "Top: \t\t" + el.style.top + "\n";
msg += "Left: \t\t" + el.style.left + "\n";
msg += "Height: \t\t" + el.style.height + "\n";
msg += "Width: \t\t" + el.style.width + "\n";
msg += "clientTop: \t" + el.clientTop + "\n";
msg += "clientLeft: \t" + el.clientLeft + "\n";
msg += "clientHeight \t" + el.clientHeight + "\n";
msg += "clientWidth: \t" + el.clientWidth + "\n\n";
msg += "offsetTop: \t" + el.offsetTop + "\n";
msg += "offsetLeft: \t" + el.offsetLeft + "\n";
msg += "offsetHeight \t" + el.offsetHeight + "\n";
msg += "offsetWidth: \t" + el.offsetWidth + "\n\n";

msg += "scrollTop: \t" + el.scrollTop + "\n";
msg += "scrollLeft: \t" + el.scrollLeft + "\n";
msg += "scrollHeight: \t" + el.scrollHeight + "\n";
msg += "scrollWidth: \t" + el.scrollWidth + "\n\n";

return msg;
}

function EPAGetGapfillById(id)
{
var all,a;
 all = document.all(eval('\''+id+'\''));
 if (all[0]) 
 {
 	for (a=0;a<all.length;a++)
		if (all[a].style.behavior.toLowerCase()=='url(#epabehavior#gapfillitem)')
			return (all[a]);
	return null;		
 }
 return(all);
}


function EPAGetObjectById(id) 
{
 all = document.all(eval('\''+id+'\''));
 if (all[0]) return (all[0]);
 return(all);
}


function DeleteXElements (aSrc){
  Del = aSrc.all('x');
  if (Del!=null) {
    if (Del.length!=null){
      for (i = Del.length-1; i >=0; i--){Del(i).removeNode(true)}
    } else {
      Del.removeNode(true);
    }
  }
};

function EPAGetAllDocumentWords() 
{
var i,s;
	s="";
  spans=document.all;
  for(i = 0; i < spans.length; i++)
  {
   if (spans(i).children.length==0)
   {
     txt=spans(i).innerText;
     if (txt.length>2) s+=txt+" ";
   }
  }
  ss=s.split(" ");
  //window.alert(ss.length);
  //for (a = 0 ; a<ss.length; a++) window.alert(ss[a]);
  return(ss);
}

function window.onbeforeprint()
{
/*
  imgs=document.all;
  for (i=0;i<imgs.length;i++)
  {
  	img0=imgs(i);
    	if (img0.filters) 
      {
      	fltrs=img0.filters;
      	for (a=0;a<fltrs.length;a++)
        {
        	if (fltrs.item(a).src) 
          {
          	if (img0.tagName=="IMG") 
            {
            	img0.src=fltrs.item(a).src;
              img0.style.width=img0.offsetWidth;img0.style.height=img0.offsetHeight;
            }
            else
            {
            Img = document.createElement ('img');
            Img.src=fltrs.item(a).src;
            
            //Img.style.position='absolute';
            //Img.style.left=img0.style.left;Img.style.top=img0.style.top;
            
            img0.appendChild(Img);
            }  
          } 
        }
        
      }
  }
*/
}
    
function window.onafterprint()
{
location.reload(true);
}


function Do_Evaluate () {
  Form=document.body.Obj;
  sstate = Form.ExStatus;
  switch (sstate) {
    case es_Normal: {
      Form.ExStatus = es_AfterEval;
      window.event.srcElement.innerText='After Evaluation';
      EvalScore.innerText = Obj.EvalScore();
      break;
    };
    case es_AfterEval: {
      Form.ExStatus = es_Removed;
      window.event.srcElement.innerText='Removed state';      
      break;
    };
    case es_Removed: {
      Form.ExStatus = es_Normal;
      window.event.srcElement.innerText='Normal state';
      break;
    };
  };
};

function SetExState (state) 
{
  Form=document.body;
  Form.Obj.ExStatus = state;
};


function RemoveXElements(Src)
{
 Utils.RemovexElements(Src);
}

function RTLGetLevel(iLevel) 
{
  strLevel = '';
  for (i = 0; i < iLevel; i++)
    strLevel = strLevel + '  ';
  return strLevel;
}

function RTLShowGroupTreePrim(obj, GroupTreeId, iLevel) 
{    
  var tree;    
  tree = obj.GroupChilds(GroupTreeId);
  if (tree == null) 
  {    
    return ""; 
  }
  else 
  {    
    var TreeLevel;
    var result;
    var TreeItem;
    var iTreeItem;
  
    TreeLevel = new VBArray(tree);
    result = '';            
    for (iTreeItem = 0; iTreeItem <= TreeLevel.ubound(1); iTreeItem++)
    {
      TreeItem = TreeLevel.getItem(iTreeItem);                        
      result = result + RTLGetLevel(iLevel) + TreeItem.id + '\n\r';      
      result = result + RTLShowGroupTreePrim(TreeItem, GroupTreeId, iLevel + 1);                  
    }
    return result;    
  }
}

function RTLShowGroupTree(obj, GroupTreeId) 
{  
  result = RTLShowGroupTreePrim(obj, GroupTreeId, 1);
  alert("Group tree '" + GroupTreeId + "' for " + obj.id + ":\n\r" + result);
}

function SetLongestLabelLength(Value)
{
  document.body.LL = Value;
}

function GetLongestLabelLength()
{
  return document.body.LL;
}


function RTLLocalize(obj, LocType, strResourceID) 
{            

 var Src = event.srcElement;
  strLoc = document.body.LocalizedData(LocType, strResourceID);    
  if (strLoc.length == 0)
	{
  	if ((document.body.Target == ti_Preview))
	  	obj.innerHTML = "!!!LocalizedStringx!!!";  
		else
			obj.innerHTML = "";
	}
  else
    obj.innerHTML = strLoc;
    
    Src.Obj.Styles = Src.Obj.Styles & (~cs_CaptureMouse) & (~cs_AllowMouseActive) | cs_NotMouseControl;

}

function GetScrollParent(Src)
{
 var a;
 a = Src;
 while (a.parentElement)
  {
    a=a.parentElement;
    if ((a.style.overflowY)||(a.style.overflowX)||(a.style.overflow)||(a.tagName=='BODY'))
       break; 
  }
 return (a);  
}


function EPARTLCheckAutoScroll() 
{
  x = window.event.clientX;
  y = window.event.clientY;
  range = 30;
  step = 5;
  scrollArea = document.body;
  scrollArea.autoScrollRange = range;
  
  if (y>scrollArea.clientHeight-range)
    document.body.scrollingDY = step;
  else
    if (y<range)
      document.body.scrollingDY = -step;
    else
      document.body.scrollingDY = 0;

  if (x>scrollArea.clientWidth-range)
    document.body.scrollingDX = step;
  else
    if (x<range)
      document.body.scrollingDX = -step;
    else
      document.body.scrollingDX = 0;

    EPARTLAutoScroll();

}
function EPARTLAutoScroll()
{
  if ((document.body.scrollingDX==0)&&(document.body.scrollingDY==0))
    return;
  isDragging=EpaDragAndDrop.Dragging();
  if (!isDragging)
    return;

  scrollArea = document.body;
  range = scrollArea.autoScrollRange;

  oldL = scrollArea.scrollLeft;
  oldT = scrollArea.scrollTop;
  scrollArea.scrollLeft = scrollArea.scrollLeft + document.body.scrollingDX;
  scrollArea.scrollTop = scrollArea.scrollTop + document.body.scrollingDY;

  if (oldT == scrollArea.scrollTop)
    document.body.scrollingDY = 0;
  if (oldL == scrollArea.scrollLeft)
    document.body.scrollingDX = 0;
 
  window.setTimeout("EPARTLAutoScroll()",10);
}

function EPASetActorIndent(Src)
{
  if (Src == null)
    Src = window.event.srcElement;      
  prnt = Src.parentElement.parentElement;
  reproWidth = 39;
  prnt.style.textIndent = -(Src.actorWidth+reproWidth);
  prnt.style.marginLeft = (document.body.ActorWidthMax+reproWidth);
}

function EPAGetActorWidth()
{
  Src = window.event.srcElement;
  w = Src.offsetWidth;
  Src.actorWidth = w;
  if ((document.body.ActorWidthMax == null) || (document.body.ActorWidthMax<w)) 
    document.body.ActorWidthMax = w;
}

function SpecialKeyPressed()
{
  if ((event.altKey) && (event.ctrlKey) && (event.keyCode == 226))
  {
    return true;
  }
  if ((event.altKey) && (event.ctrlKey) && (event.keyCode == 222))
  {
    return true;
  }

  
}

function PlgHeading(object)
{  
  object.style.height = object.offsetHeight;
  object.style.width = "100%";
}

function PlgInitVocabulary(object, vline)
{
 vline.style.width = object.offsetWidth * 0.9;
}


function EPATitleHintShow()
{
  var Src = event.srcElement;
  if (Src.firstChild.innerText.length>0)
  {
    Src.firstChild.className='RTS_HeadingTitleHint';
    pos = EPAGetAbsolutePosition(Src);
	if (Src.firstChild.offsetWidth+2<document.body.clientWidth-pos.x-8)
    	Src.firstChild.style.width=Src.firstChild.offsetWidth+2;
	else
		Src.firstChild.style.width=document.body.clientWidth-pos.x-30;
    Src.firstChild.style.top=pos.y-3;
    Src.firstChild.style.left=pos.x+8;
  }
}

function EPATitleHintHide()
{
event.srcElement.firstChild.style.width='auto';
event.srcElement.firstChild.className='RTS_HeadingTitleHintHidden';
}

function EPAInstructionHintShow()
{
  var Src = event.srcElement;
  if (Src.firstChild.innerText.length>0)
  {
    Src.firstChild.className='RTS_InstructionTitleHint';
    pos = EPAGetAbsolutePosition(Src);
	if (Src.firstChild.offsetWidth+2<document.body.clientWidth-pos.x-8)
    	Src.firstChild.style.width=Src.firstChild.offsetWidth+2;
	else
		Src.firstChild.style.width=document.body.clientWidth-pos.x-30;
    Src.firstChild.style.top=pos.y-8;
    Src.firstChild.style.left=pos.x+8;
  }  
}

function EPAInstructionHintHide()
{
  event.srcElement.firstChild.style.width='auto';
  event.srcElement.firstChild.className='RTS_InstructionTitleHintHidden';
}


function RTS_Rewise_Fact_Add()
{
  var Src = event.srcElement;
  row = Src.parentElement;
  if (Utils.IsPhraseInRewise(row.id))
  {
    Src.style.color='gray';
    Src.firstChild.src=crs_ImagesPath+'rewise/icon_rewise01Disabled.gif';
  }
  else
  {
    Src.style.cursor='hand';
    Src.onclick=RTS_Rewise_Fact_Add_OnClick;
  }
}

function RTS_Rewise_Fact_Add_OnClick()
{
  var Src = event.srcElement;
  if (Src.tagName=='IMG')
    Src = Src.parentElement;
  row = Src.parentElement;
  alertwindow = "<table id='rewiseAlertWindow' style='position:absolute;top:0;left:0;' class='RTS_rewiseaddwarning'><tr><td>"+Utils.GetRunTimeLocStr('AddToREWISEProgressText')+"</td></tr></table>";
  aw = document.all('rewiseAlertWindow');
  if (aw!=null)
    aw.removeNode(true);
  document.body.insertAdjacentHTML('beforeEnd',alertwindow);
  aw = document.all('rewiseAlertWindow');
  aw.style.left=(document.body.clientWidth-aw.offsetWidth)/2+document.body.scrollLeft;
  aw.style.top=(document.body.clientHeight-aw.offsetHeight)/2+document.body.scrollTop;
  //alert(aw.outerHTML);
  document.body.alertobj = aw;																		
  t1 = row.cells[row.cells.length-1].innerText;
  if (t1.indexOf(' EpAb ')!=-1)
  	 t1 = t1.substring(6,t1.length-6);  // vymaze z textu &nbsp;EpAb&nbsp; a &nbsp;EpAe&nbsp;
  t1 = escape(t1);
  t2 = row.cells[1].innerText;
  t2 = escape(t2);
  window.setTimeout('Utils.AddPhraseToRewise("'+row.id+'",unescape("'+t1+'"),unescape("'+t2+'"));document.body.alertobj.removeNode(true);',1000);
  
  //Utils.AddPhraseToRewise(row.id,row.cells[row.cells.length-1].innerText,row.cells[1].innerText);
  //aw.removeNode(true);
  Src.style.color='gray';
  Src.style.cursor='auto';
  Src.firstChild.src=crs_ImagesPath+'rewise/icon_rewise01Disabled.gif';
  
}

function RTS_Rewise_Fact_AddAll()
{
  var Src = event.srcElement;
  tbl = EPAGetObjectById(Src.TableId);
  dis = true;
  for (a=1;a<tbl.rows.length;a++) // az od druhe radky, v prvni je colspan=4 a tlacitko 'AddAll'
  {
    if (!Utils.IsPhraseInRewise(tbl.rows[a].id))
    {
      dis = false;
      break;
    }
  }
  if (dis)
  {
    Src.style.color='gray';
    Src.firstChild.src=crs_ImagesPath+'rewise/icon_rewise01allDisabled.gif';
  }
  else
  {
    Src.style.cursor='hand';
    Src.onclick=RTS_Rewise_Fact_AddAll_OnClick;
  }
}


function RTS_Rewise_Fact_AddAll_OnClick()
{
  var Src = event.srcElement;
  if (Src.tagName=='IMG')
    Src = Src.parentElement;
  tbl = EPAGetObjectById(Src.TableId);
  for (a=1;a<tbl.rows.length;a++) // az od druhe radky, v prvni je colspan=4 a tlacitko 'AddAll'
  {
    tbl.rows[a].cells[0].click();
  }
  Src.style.color='silver';
  Src.firstChild.src=crs_ImagesPath+'rewise/icon_rewise01allDisabled.gif';
  Src.style.cursor='auto';
}

function GetExScore(exs)
	// Naplni ve strance elementy:
	//   TestResults .. prumerne hodnoceni ze otovych cviceni
	//   TestToDo .. pocet nehotovych cviceni
{
  Src = window.event.srcElement;     
  var ss,sc,scm,p,sct;
  ss = exs.split(" ");
  sc = 0;  
  scm = 0;
  p = 0;
  DoneEx=0;
  for (a=0;a<ss.length;a++)
  {
    var x = Utils.GetExInfoByUrl(ss[a]).split('|');
    if (x[1] <= 0) {
    	p += 1;	
    } else
    {
    // sc += parseInt(x[0]);
    // scm += parseInt(x[1]);
    if (parseInt(x[1]) > 0) {
    	sc +=parseInt(x[0])/parseInt(x[1]);
// alert('sc:'+sc);
    };
    DoneEx += 1;

    };
// alert('x[0]:'+x[0]);
// alert('x[1]:'+x[1]);  
  }
  if (DoneEx <= 0) 
  	{sct = 0}
  else
  	{sct = Math.round((sc/DoneEx)*100)}
  rid = document.all('TestResult');
  rid.innerText = sct +'%';
  cid = document.all('TestToDo');
  cid.innerText = p;
  return sct;
}
